<?php
// $Id: linktonode_category.inc,v 1.12 2006/10/22 12:46:47 stborchert Exp $

/**
 * linktonode_category
 * category extension for plugin linktonode
 */

class linktonode_category {

  function linktonode_category() {
  }

  function get_nodes($container, $parent = -1) {
    $results = array();
    $types = variable_get('linktonode_node_types', array());
    if ($container < 0)
      $container = 0;

    $cid = $container;
    if ($parent > 0)
      $cid = $parent;

    $categories = $this->_get_categories($cid);
    $type = '';
    $node = null;
    foreach( $categories as $key => $category) {
      $cat = module_invoke('category', 'get_category', $key);
      // choose type
      $type = 'category-cat';
      if ($cat->cnid == 0)
        $type = 'category-cont';
			if (!isset($types[$type])
				|| ($types[$type] !== $type))
				continue;

      $node = module_invoke('node', 'load', $cat->cid);
      $obj = new StdClass;
      $obj->nid = $node->nid;
      $obj->title = $node->title;
      $obj->date = format_date($node->changed, 'small');
      $obj->author = $node->name;
      $obj->type = $type;
      $obj->href = url('node/' . $node->nid);
      $obj->orig_href = 'taxonomy/' . ($type == 'category-cat' ? 'term/' : 'vocabulary/') . $obj->nid; // used to remove duplicate entries
      $results[$obj->orig_href] = $obj;
    }
    return $results;
  }

  function find_nodes($search) {
  }

  function get_title() {
    return t('category');
  }

  function settings(){
    return array('category-cont' => t('container'),
			'category-cat' => t('category'));
  }

  function settings_submit($form_id, $values){
  }

  function check_dependencies() {
    if (!module_exist('category')) {
      return false;
    }
    return true;
  }

  function _get_categories($parent) {
    $results = array();
    $sql = db_rewrite_sql('SELECT c.cid, c.*, h.parent, n.title FROM {category} c INNER JOIN {category_hierarchy} h ON c.cid = h.cid INNER JOIN {node} n ON c.cid = n.nid LEFT JOIN {category} c2 ON h.parent = c2.cid WHERE h.parent = %d AND n.status = 1 AND n.moderate = 0 ORDER BY c.weight, n.title', 'n', 'nid');
    $result = db_query($sql, $parent);
    while ($category = db_fetch_object($result)) {
      $results[$category->cid] = $category;
    }
    return $results;
  }
}
?>