<?php
// $Id: linktonode_default.inc,v 1.9 2006/10/26 14:42:26 stborchert Exp $

/**
 * linktonode_default
 * default extension for plugin linktonode
 */

class linktonode_default {

  function linktonode_default() {
  }

  function get_nodes($container, $parent = -1) {
    $results = array();
    $types = variable_get('linktonode_node_types', array());
		$nodes = $this->_select_nodes(($container <= 0 ? -1 : $parent));
    $obj = null;
    while ($nd = db_fetch_object($nodes)) {
      $node = node_load($nd->nid);
			if (!isset($types[$node->type])
				|| ($types[$node->type] !== $node->type))
				continue;

      $obj = new StdClass;
      $obj->nid = $node->nid;
      $obj->title = $node->title;
      $obj->date = format_date($node->changed, 'small');
      $obj->author = $node->name;
      $obj->type = $node->type;
      $obj->href = url('node/' . $node->nid);
      $obj->orig_href = 'node/' . $obj->nid; // used to remove duplicate entries
      $results[$obj->orig_href] = $obj;
    } // while
		return $results;
  }

  function find_nodes($search) {
    return array();
  }

  function get_title() {
    return t('default');
  }

  function settings() {
    return array('story' => t('story'),
			'page' => t('page'));
  }

  function settings_submit($form_id, $values) {
  }

  function check_dependencies() {
    return true;
  }

  function _select_nodes($tid) {
    $order = 'n.sticky DESC, n.created DESC';
    $descendant_tids = array();
    $term = taxonomy_get_term($tid);
    $tree = taxonomy_get_tree($term->vid, $tid, -1, 0);
    $descendant_tids[] = array_merge(array($tid), array_map('_taxonomy_get_tid_from_term', $tree));

    $str_tids = implode(',', call_user_func_array('array_merge', $descendant_tids));
    $join = 'INNER JOIN';
    $where = 'tn.tid IN (' . $str_tids . ')';
    if ($tid < 0) {
      $join = 'LEFT JOIN';
      $where = 'ISNULL(tn.tid)';
    }
    $sql = 'SELECT DISTINCT(n.nid), n.sticky, n.title, n.created, tn.tid FROM {node} n ' . $join . ' {term_node} tn ON n.nid = tn.nid WHERE ' . $where . ' AND n.status = 1 ORDER BY '. $order;

    $result = db_query(db_rewrite_sql($sql));

    return $result;
  }
}
?>
