// $Id: dropdown.js,v 1.3 2006/10/21 16:08:47 stborchert Exp $

/**
 *
 * @access public
 * @return void
 **/
function _createDropdown(obj){
  var dropdown;
  var elemname;
  try {
    elemname = obj.parentNode.id;
    _removeDescendant(obj);
  }
  catch (e) {
    elemname = 'browse_sel_-1';
  }

  var level = parseInt(elemname.substring(elemname.lastIndexOf("_") + 1, elemname.length)) + 1;

  var elemBase = elemname.substring(0, elemname.lastIndexOf("_") + 1);

  // create surrounding <div>
  var sel_div = document.createElement('div');
  sel_div.setAttribute("name", elemBase + level);
  sel_div.setAttribute("id", elemBase + level);
  sel_div.setAttribute("style", "display: block; margin: 1px 0; padding: 0; border: 0;");

  // create <select>
  var select = document.createElement('select');
  select.setAttribute("size", 1);
  select.setAttribute("name", elemBase + level + "_sel");
  select.setAttribute("id", elemBase + level + "_sel");

  // add event handler
  select.onchange = function() {
    _removeDescendant(this.parentNode);
    _clearNodeList();
    loadCategories(this);
  }

  // create image (only if level > 0)
  if (level > 0) {
    var img = document.createElement('img');
    img.setAttribute("id", elemname.substring(0, elemname.lastIndexOf("_") + 1) + level + '_img');
    img.setAttribute("style", "margin: 0px 2px; border: 0;");
    img.setAttribute("alt", "");
    img.setAttribute("src", "images/descendant.gif");
    // extra margin for IE
    img.style.marginLeft = String((parseInt(level) - 1) * 14) + 'px';
    img.style.marginRight = '2px';
    $(sel_div).append(img);
  }

  $(sel_div).append(select);
  $(sel_div).hide();
  $("#form_browse").append(sel_div);
  $(sel_div).show("slow");
  return select;
}

/**
 * _fillDropdown
 * @return true if a dropdown was inserted
 **/
function _fillDropdown(obj, results){
  if (results.category != false) {
    var select = _createDropdown(obj);
    $(select).addOption(-1, tinyMCELang['lang_linktonode_choose_category']);
    for (key in results.category)
      $(select).addOption(results.category[key].tid, results.category[key].title);
    return true;
  }
  return false;
}

/**
* remove "child" elements
**/
function _removeDescendant(elem) {
  if (elem == null)
    return;
  $(elem).next().each(
    function() {
      _removeDescendant(this);
      window.resizeBy(0, -17);
      $(this).hide("slow").remove();
    }
  );
}
